#include <iostream>
#include <string>

using namespace std;

class eloleny{
protected:
    unsigned kromoszomaszam;
public:
    eloleny(unsigned k):kromoszomaszam(k){
        cout << "eloleny letrehozva" << endl;
    }
    
    virtual ~eloleny(){
        cout << "eloleny torolve" << endl;
    }
    
    virtual void taplalkozik()const = 0;
};

class noveny: public eloleny{
    unsigned klorofill_hatekonysag;
    unsigned kromoszomaszam; //just for fun
    
    void fotoszintetizal()const{
        cout << "a noveny " << klorofill_hatekonysag <<" db energiat allitott elo" << endl;
    }
public:
    noveny(unsigned k1, unsigned k2):eloleny(k2), klorofill_hatekonysag(k1), kromoszomaszam(2*k2){
        cout <<"novenybeli krom:" << kromoszomaszam << endl;
        cout <<"osbeli krom:" << eloleny::kromoszomaszam << endl;
    }
    
    ~noveny(){
        cout << "noveny destr" << endl;
    }
    
    void taplalkozik()const{
        fotoszintetizal();
    }
};


class allat: public eloleny{
protected:
    bool novenyevo;
public:
    allat(bool n, unsigned k):eloleny(k), novenyevo(n){
        cout << "allat letrehozva" << endl;
    }
    
    ~allat(){
        cout << "allat torolve" << endl;
    }
    
    void taplalkozik()const override{
        if(novenyevo){
            cout << "legel" << endl;
        }
        else{
            cout << "vadaszik" << endl;
        }
    }
};

class macska: public allat{
    string nev;
public:
    macska(const string& n): allat(false, 38), nev(n){
        cout << "macska letrehozva:" << kromoszomaszam << endl;
    }
    
    ~macska(){
        cout << "macska torolve" << endl;
    }
    
    void taplalkozik()const override{
        cout << nev << " egeret ";
        allat::taplalkozik();
    }
};

//ertek
void etet(allat a){
   a.taplalkozik(); 
}

void etet_ref(const allat& a){
   a.taplalkozik(); 
}

void etet(allat* a){
   a->taplalkozik(); 
}


int main(){
    /*allat a(false);
    macska m("Mimi");
    
    etet_ref(a);
    etet_ref(m);
    
    etet(&a);
    etet(&m);
    
    etet(a);
    etet(m);
    eloleny * m = new macska("Mimi");
    m->taplalkozik();
    delete m;*/
    
    //noveny n(5, 10);
    eloleny * n = new noveny(5,10);
    n->taplalkozik();
    delete n;
    
}