#include <iostream>

using namespace std;

class SIMKartya {
private:
  string szam;
public:
  SIMKartya(string p_szam) {
    szam = p_szam;
  }
  
  string get_szam() {
    return szam;
  }

  friend class Szolgaltato;
};

class Telefon {
  SIMKartya *kartya = nullptr;
public:
  void kartya_hozzaadas(SIMKartya *kartya) {
    this->kartya = kartya;
  }
  
  void kartya_kivetel() {
    kartya = nullptr;
  }
  
  string get_telefonszam() {
    return kartya->get_szam();
  }
};

void kartya_csere(Telefon *telefon, SIMKartya *uj_kartya) {
  cout << "csere(po):  A telefon szama: " << telefon->get_telefonszam() << endl;
  telefon->kartya_hozzaadas(uj_kartya);
  cout << "csere(po):  A telefon uj szama: " << telefon->get_telefonszam() << endl;
}

void kartya_csere(Telefon &telefon, SIMKartya &uj_kartya) {
  cout << "csere(ref): A telefon szama: " << telefon.get_telefonszam() << endl;
  telefon.kartya_hozzaadas(&uj_kartya);
  cout << "csere(ref): A telefon uj szama: " << telefon.get_telefonszam() << endl;
}

class Szolgaltato {
public:
  void szam_csere(SIMKartya& kartya, const string& uj_szam) {
    kartya.szam = uj_szam;
  }
};

int main() {
  SIMKartya sim("123456");
  cout << "A kartya szama: " << sim.get_szam() << endl;
  
  Telefon telefon;
  telefon.kartya_hozzaadas(&sim);
  cout << "A telefon szama: " << telefon.get_telefonszam() << endl;
  
  SIMKartya uj_kartya("333444");
  kartya_csere(&telefon, &uj_kartya);
  cout << "main:       A telefon uj szama: " << telefon.get_telefonszam() << endl;

  SIMKartya uj_kartya_2("999999");
  kartya_csere(telefon, uj_kartya_2);
  cout << "main:       A telefon uj szama: " << telefon.get_telefonszam() << endl;

  Szolgaltato szolgaltato;
  szolgaltato.szam_csere(uj_kartya_2, "123123");
  cout << "A kartya szama: " << uj_kartya_2.get_szam() << endl;
  cout << "main:       A telefon uj szama: " << telefon.get_telefonszam() << endl;
}
