#include <iostream>
#include <string>

using namespace std;

class Hallgato {
  string nev, kod;
public:
  Hallgato() {
  }

  Hallgato(const string& nev, const string& kod) : nev(nev), kod(kod) {
  }
  
  const string& get_nev() const {
    return nev;
  }
  
  const string& get_kod() const {
    return kod;
  }
};


class Kurzus {
  string nev, kod;
  unsigned felvette = 0;
  Hallgato hallgatok[10];
public:
  Kurzus(const string& nev, const string& kod) : nev(nev), kod(kod) {
  }

  const string& get_nev() const {
    return nev;
  }

  const string& get_kod() const {
    return kod;
  }

  Kurzus& operator+=(const Hallgato& hallgato) {
    if (felvette < 10)
      hallgatok[felvette++] = hallgato;
    else
      cout << "HIBA: a kurzus betelt, " << hallgato.get_nev() << " nem tudja felvenni" << endl;
    return *this;
  }
  
  Kurzus operator+(const Hallgato& hallgato) const {
    Kurzus k = *this;
    if (k.felvette < 10)
      k.hallgatok[k.felvette++] = hallgato;
    else
      cout << "HIBA: a kurzus betelt, " << hallgato.get_nev() << " nem tudja felvenni" << endl;
    return k;
  }
  
  Kurzus& operator+=(const Kurzus& kurzus) {
    for (unsigned i = 0; i < kurzus.felvette; i++)
      //*this += kurzus.hallgatok[i];
      operator+=(kurzus.hallgatok[i]);
    return *this;
  }
  
  Kurzus operator+(const Kurzus& kurzus) const {
    Kurzus k = *this;
    k += kurzus;
    return kurzus;
  }
  
  void kiir() const {
    cout << nev << "(" << kod << ")" << endl;
    for (unsigned i = 0; i < felvette; i++)
      cout << "  " << hallgatok[i].get_nev() << "(" << hallgatok[i].get_kod() << ")" << endl;
    cout << endl;
  }
};


int main() {
  Hallgato h1("Kiss Geza", "A1B2C3"), h2("Szabo Anna", "DEF456");
  Kurzus k1("Programozas II.", "IB302G-1");
  k1 = k1 + h1;
  k1 += h2;

  Kurzus k2("Programozas II.", "IB302G-2");
  for (int i = 0; i < 12; i++)
    k2 += Hallgato{"nev_"+to_string(i), "kod:"+to_string(i+100)};
  k1.kiir();
  k2.kiir();
  
  k1 += k2;
  k1.kiir();
}
