#include <iostream>
#include <string>

using namespace std;

class Hallgato {
  string nev, kod;
public:
  Hallgato() {
  }

  Hallgato(const string& nev, const string& kod) : nev(nev), kod(kod) {
  }
  
  const string& get_nev() const {
    return nev;
  }
  
  const string& get_kod() const {
    return kod;
  }
};


class Kurzus {
  string nev, kod;
  unsigned felvette = 0;
  Hallgato hallgatok[10];
public:
  Kurzus(const string& nev, const string& kod) : nev(nev), kod(kod) {
  }

  const string& get_nev() const {
    return nev;
  }

  const string& get_kod() const {
    return kod;
  }

  Kurzus& operator+=(const Hallgato& hallgato) {
    if (felvette < 10)
      hallgatok[felvette++] = hallgato;
    else
      cout << "HIBA: a kurzus betelt, " << hallgato.get_nev() << " nem tudja felvenni" << endl;
    return *this;
  }
  
  Kurzus operator+(const Hallgato& hallgato) const {
    Kurzus k = *this;
    if (k.felvette < 10)
      k.hallgatok[k.felvette++] = hallgato;
    else
      cout << "HIBA: a kurzus betelt, " << hallgato.get_nev() << " nem tudja felvenni" << endl;
    return k;
  }
  
  Kurzus& operator+=(const Kurzus& kurzus) {
    for (unsigned i = 0; i < kurzus.felvette; i++)
      //*this += kurzus.hallgatok[i];
      operator+=(kurzus.hallgatok[i]);
    return *this;
  }
  
  Kurzus operator+(const Kurzus& kurzus) const {
    Kurzus k = *this;
    k += kurzus;
    return kurzus;
  }
  
  Hallgato& operator[](unsigned i) {
    if (i < felvette)
      return hallgatok[i];
    // valodi hibakezeles szukseges, ami majd kesobb jon
    cout << "HIBA: nincs " << i << " darab hallgato a kurzushoz rendelve" << endl;
    return hallgatok[0]; // nem szep, de ...
  }
  
  const Hallgato& operator[](unsigned i) const {
    if (i < felvette)
      return hallgatok[i];
    // valodi hibakezeles szukseges, ami majd kesobb jon
    cout << "HIBA (const): nincs " << i << " darab hallgato a kurzushoz rendelve" << endl;
    return hallgatok[0]; // nem szep, de ...
  }
  
  void kiir() const {
    cout << nev << "(" << kod << ")" << endl;
    for (unsigned i = 0; i < felvette; i++)
      cout << "  " << hallgatok[i].get_nev() << "(" << hallgatok[i].get_kod() << ")" << endl;
    cout << endl;
  }
};

void test(const Kurzus& k) {
  cout << k[0].get_nev() << endl;
  cout << k[1].get_nev() << endl;
  cout << k[2].get_nev() << endl;
}

int main() {
  Hallgato h1("Kiss Geza", "A1B2C3"), h2("Szabo Anna", "DEF456");
  Kurzus k1("Programozas II.", "IB302G-1");
  k1 = k1 + h1;
  k1 += h2;
  
  cout << k1[0].get_nev() << endl;
  cout << k1[1].get_nev() << endl;
  cout << k1[2].get_nev() << endl;
  cout << endl;
  
  test(k1);
}
