/**
 * Feladatok:
 * 1, Legyen egy dokumentum osztály
 *   - címmel (str)
 *   - tartalommal (str, default param: "")
 *   - szerzővel (str, default param: "anonym")
 *   - megnyitasokkal (unsigned, kezdő érték 0)
 * 2, Készíts hozzá gettert a tanult módon
 *   - minden getter növelje a megnyitasokat eggyel. (Kivéve az azt lekérdező) (itt ugye muszáj, hogy mutable legyen)
 * 3, Valósítsd meg a pre és post incremental operátort
 *   - növelje a megnyitasok számát eggyel (Mintha csak touch lenne vagy ilyesmi)
 * 4, Valósítsd meg a += operátort, mely egy stringet fűz a tartalomhoz
 * 5, Valósítsd meg a + operátort, mely egy stringet fűz a tartalomhoz,
 *    de azt csak egy saved_as című dokumentumba teszi bele. (save as.. funkcionalitás)
 * 6, A Dokumentum konvertálható legyen unsigned típusra, mely a tartalom hosszát adja eredményül.
 *   - a konverzió ne történjen meg implicit módon!
 * 7, A Dokumentum negálása (operator!) megvalósítása (unsigned visszatérési típussal)
 *   - üres dokumentum esetén Lorem ipsum.. szöveget írja bele
 *   - bármilyen tartalom esetében törölje azt.
 *   - visszatérési értékben az új tartalom hossza szerepeljen
*/

#include <iostream>
#include <string>

using namespace std;

class Dokumentum
{
    string cim;
    string tartalom;
    const string szerzo;
    mutable unsigned megnyitasok = 0;

public:
    Dokumentum(const string &cim, const string &tartalom = "", const string &szerzo = "anonym") : cim(cim),
                                                                                                  tartalom(tartalom),
                                                                                                  szerzo(szerzo) {}

    const string &get_tartalom() const
    {
        ++megnyitasok;
        return tartalom;
    }
    const string &get_szerzo() const
    {
        ++megnyitasok;
        return szerzo;
    }
    unsigned get_megnyitasok() const { return megnyitasok; }

    Dokumentum &operator+=(const string &extra)
    {
        tartalom += extra;
        return *this;
    }

    Dokumentum operator+(const string &extra)
    {
        Dokumentum saved_as("saved_as", this->tartalom, this->szerzo);
        saved_as += extra;
        return saved_as; // adjuk vissza az uj dokumentumot. Nem lehet referencia
        // Ha referencia lenne, akkor az erre az objektura utalna, de a metodus lefutasa utan
        // ez az objektum megszunik. Nem lenne celszeru egy megszunt objektumra utalni.
        // Erre a fordito is figyelmeztet.
    }

    Dokumentum &operator++()
    {
        ++megnyitasok;
        return *this;
    }

    const Dokumentum &operator++() const
    {
        ++megnyitasok;
        return *this;
    }
    Dokumentum operator++(int)
    {
        Dokumentum old = *this;
        operator++();
        return old;
    }

    explicit operator unsigned() const { return tartalom.length(); }

    unsigned operator!()
    {
        if (tartalom.length())
        {
            tartalom = "";
        }
        else
        {
            tartalom = "Lorem ipsum...";
        }

        return tartalom.length();
    }
};

void hossz(unsigned u)
{
    cout << "A hossz: " << u << endl;
}

int main()
{
    Dokumentum d("szakdolgozat.docx");
    cout << d.get_tartalom() << endl;
    !d;
    cout << d.get_tartalom() << endl;
    d += "g++";
    cout << d.get_tartalom() << endl;
    cout << d.get_megnyitasok() << endl;

    const Dokumentum d_mentes = d + " main.cpp";
    cout << d_mentes.get_tartalom() << endl;

    hossz((unsigned)d_mentes);
}