#include <iostream>
#include <string>

using namespace std;

/*
Írj egy Virag osztály! A virág egyetlen attribútuma a színe, ezt tárolja egy sztring.
Írj paraméteres konstruktort az osztályhoz, mely kiírja a standard outputra, hogy "X szinu virag letrehozva".
Írd meg a következő metódusokat is a kettőspont után szereplő kiíratásokkal:
- destruktor: "X szinu virag torolve"
- copy konstruktor: "X szinu virag masolva copy konstruktorral"
- assignment operator: "X szinu virag masolva ertekadas operatorral"

Írj egy metódust, ami virág paramétert vár
- érték szerint
- referencia szerint
Vizsgáld meg a kiíratott sorokat!

Írj egy metódust, ami virágot ad vissza:
- érték szerint
- referencia szerint
Vizsgáld meg a kiíratott sorokat!

Írj egy Kert osztályt, ami tetszőleges számú virágot tartalmaz egy dinamikus tömbben.
Írj neki egy konstruktort, ami egy unsigned értéket, a leendő virágok számát várja.
Gondoskodj a destruktorról is!

Valósítsd meg a += operátort, ami egy virágot vár paraméterül és a Kert első szabad helyéhez adja. Ha nincs már
hely a tömbben ne csináljon semmit.

Valósítsd meg a (nem konstans) indexer operátort az i-edik virág lekérdezésére. Ha az index rossz legyen a 0-ás tömbelem visszaadva.

Készíts egy kiir metódust, amely sorban egymás után kiírja a kertben aktuálisan szereplő virágok színét

Próbáld ki a kert lemásolását (main-ben, függvény paraméterként), figyeld a hatást.
Valósítsd meg helyesen a copy konstruktorokat és az assignment operátort a kert osztályra!
*/

class Virag{
    string szin;
public:
    Virag(const string& sz = "piros"):szin(sz){
        cout << szin << " szinu virag letrehozva" << endl;
    }
    
    ~Virag(){
        cout << szin << " szinu virag torolve" << endl;
    }
    
    Virag(const Virag& orig):szin(orig.szin){
        cout << szin << " szinu virag masolva copy konstruktorral" << endl;
    }
    
    Virag& operator=(const Virag& orig){
        szin = orig.szin;
        cout << szin << "  szinu virag masolva ertekadas operatorra" << endl;
        return *this;
    }
    
    const string& get_szin()const{
        return szin;
    }
    
    void set_szin(const string s){
        szin = s;
    }
    
};

void virag_user(Virag v){
    cout << v.get_szin() << " hasznalva" << endl;
}

void virag_user_ref(const Virag& v){
    cout << v.get_szin() << " hasznalva" << endl;
}

Virag virag_return(){
    Virag v("zold");
    return v;
}

class Kert{
    Virag* viragok;
    unsigned max, aktualis;
    
public:
    Kert(unsigned m):viragok(new Virag[m]), max(m), aktualis(0){
    }
    
    ~Kert(){
        delete[] viragok;
    }
    
    //+=
    Kert& operator+=(const Virag& v){
        if(aktualis < max){
            viragok[aktualis++] = v; //assignment op virag
            //aktualis++;
        }
        return *this;
    }
    
    //[], nem konstans
    Virag& operator[](unsigned i){
        if(i >= aktualis){
            return viragok[0];
        }
        return viragok[i];
    }
    
    //kiir
    void kiir() const{
        for(unsigned i=0;i<aktualis;++i){
            cout << i << ":" << viragok[i].get_szin() << endl;
        }
    }
    
    Kert(const Kert& orig):viragok(new Virag[orig.max]), max(orig.max), aktualis(orig.aktualis){
        for(unsigned i=0;i<aktualis;++i){
            viragok[i] = orig.viragok[i]; //assignment
        }
    }
    
    Kert& operator=(const Kert& orig){
        delete[] viragok;
        viragok = new Virag[orig.max];
        max = orig.max;
        aktualis = orig.aktualis;
        for(unsigned i=0;i<aktualis;++i){
            viragok[i] = orig.viragok[i]; //assignment
        }
        return *this;
    }
};

void kert_masolo(Kert k){
    k.kiir();
}


int main(){
    Kert k(5);
    Virag v("fekete");
    Virag v2("zold");
    k+=v;
    k+=v2;
    cout << "k kert:-----------" << endl;
    k.kiir();
    
    Kert k2(20);
    cout << "kert assignment" << endl;
    k2 = k;
    cout << "kert assignment vege" << endl;
    
    /*Kert k2(k);
    cout << "k2 kert:-----------" << endl;
    k2.kiir();
    
    k2[1].set_szin("kek");
    cout << "k2 kert:-----------" << endl;
    k2.kiir();
    cout << "k kert:-----------" << endl;
    k.kiir();*/
    
    //kert_masolo(k);
    //cout << "kert masolo vege" << endl;
    
   /* Virag v("fekete");
    Virag v2(v); //copy konstruktort
    
    Virag v3("kek");
    
    virag_user_ref(v3);
    
    v3 = v; //assigment operator
    
    Virag v4 = virag_return();
    cout << v4.get_szin() << " hasznalva" << endl;*/
    
}