#include <iostream>
#include <string>

using namespace std;

class Jarmu {
    string uzemanyag;
public:
    Jarmu(const string& uzemanyag) : uzemanyag(uzemanyag) {}

    const string& get_uzemanyag() const {
        return uzemanyag;
    }

    virtual void halad() const {
        cout << "A Jarmu halad es " << uzemanyag << "-t fogyaszt." << endl;
    }
};

class Auto : public Jarmu {
    unsigned sebesseg;
public:
    Auto(const string& uzemanyag, int sebesseg) : Jarmu(uzemanyag), sebesseg(sebesseg) {}

    unsigned int get_sebesseg() const {
        return sebesseg;
    }

    void halad() const override {
        cout << "Az Auto " << sebesseg << "km/h-val halad es " << get_uzemanyag() << "-t fogyaszt." << endl;
    }
};

class Hajo : public Jarmu {
    float sebesseg;
public:
    Hajo(const string& uzemanyag, float sebesseg) : Jarmu(uzemanyag), sebesseg(sebesseg) {}

    float get_sebesseg() const {
        return sebesseg;
    }

    void halad() const override {
        cout << "A Hajo " << sebesseg << " csomoval halad es " << get_uzemanyag() << "-t fogyaszt." << endl;
    }
};

void jarmu_halad(const Jarmu& j) {
    j.halad();
}

int main() {
    Jarmu j("kerozin");
    Auto a("benzin", 200);
    Hajo h("dizel", 12.5);

    jarmu_halad(j);
    jarmu_halad(a);
    jarmu_halad(h);
}
